#include <cstdio>

#include <SFML/Audio.hpp>
#include <SFML/Graphics.hpp>

int main()
{
	// # Create the main window and camera
	//
	// ## TODO
	// - [ ] Make framerate limit adjustable
	// - [ ] Make video and camera size the same as hardware window size
	// - [ ] Resize video and camera size when user resizes window.
	//
	const int WIDTH = 800;
	const int HEIGHT = 600;
	const int FRAMERATE_LIMIT = 90;
	sf::RenderWindow window(sf::VideoMode(WIDTH, HEIGHT), "Double trouble");
	window.setFramerateLimit(FRAMERATE_LIMIT);
	sf::View camera(sf::FloatRect(0, 0, WIDTH, HEIGHT));
	camera.setCenter(0, 0);
	window.setView(camera);

	// # Create things
	sf::CircleShape circle;
	circle.setPosition(0, 0);
	circle.setRadius(10);
	circle.setFillColor(sf::Color::Red);

	while (window.isOpen())
	{
		// # Process events
		sf::Event event;
		while (window.pollEvent(event))
		{
			// ## Close window on exit
			if (event.type == sf::Event::Closed ||
				event.type == sf::Event::KeyPressed &&
					event.key.code == sf::Keyboard::Escape)
			{
				window.close();
			}
		}

		// # Render video
		window.clear();
		window.draw(circle);
		window.display();
	}
	return 0;
}
