# Game Design Document

*Authored by: Jonas and Viktor*
*Repo: https://git.gvk.idi.ntnu.no/jonasjso/double-trouble*
*Template: [A GDD Template for the Indie developer](https://www.gamasutra.com/blogs/JasonBakker/20090604/84211/A_GDD_Template_for_the_Indie_Developer.php) 22.08.2020*

## Idea 1: Satan's fight pit ✅ 👍

### 1.1 The Pitch
A 2D-platformer brawl game, where you play as one of the tortured souls in hell that fights in Satan’s pit for the chance of winning the prize that all the souls in hell wish for the most. To return to earth. To win you, alone or with a friend, must fight in Satan’s pit and gather points by completing the objectives that spawn inside the pit while battling against other tortured souls that are trying to do the same.

### 1.2 Game type
- 2-D platformer
- Brawl
- Fighting
- Supernatural

### 1.3 Inspiring games
- Luigis Mansion
- Mario Kart
- Playing with fire 2 - https://www.crazygames.com/game/playing-with-fire-2
- Fall guys - https://store.steampowered.com/app/1097150/Fall_Guys_Ultimate_Knockout/
- PUBG - https://store.steampowered.com/app/578080/PLAYERUNKNOWNS_BATTLEGROUNDS/

## Idea 2: Battery guy! 🔋🔋🔋 ❌ 👎

### 1.1 The Pitch
- You are "Battey guy". With the `power` to store and dispatch `electricity` through your `conducting` fingertips, you are ready to `charge` your way out of imprisonment and save the world from "the eternal darkness". Play alone, or co-op with a friend, in this `shocking`, `supercharged`, `electrifying` puzzle game.

### 1.2 Game type
- The game is a 2D puzzle adventure game. The player will face problems which will be solved by using the power of the players electric conducting hands. The player may choose between single-player puzzles, or co-op puzzles. The player starts as a prisoner, and must escape. 
- Use hands to turn on/off lights
- Use hands to charge/discharge battery
- Use hands to move vehicles/trains
- Use hands to play radio
- Use hands to broadcast radio
- Use hands to cook, freeze, blow air
- Of course it is not the player directly doing all these things, but the appliances he finds, which he can power to do work for him.

### 1.3 Inspiring games
- Teslagrad - https://store.steampowered.com/app/249590/Teslagrad/
- Portal 1 and 2 - https://store.steampowered.com/app/620/Portal_2/
- Lovers in a dangerous spacetime - https://store.steampowered.com/app/252110/Lovers_in_a_Dangerous_Spacetime/
- Overcooked - https://store.steampowered.com/app/448510/Overcooked/
- Zelda tri-force-heroes - https://en.wikipedia.org/wiki/The_Legend_of_Zelda:_Tri_Force_Heroes


## 2. The plot
Satan is getting bored and wants some entertainment, so he gets the souls of most evil humans to fight each other for a ticket to be put back on earth. What they do not know is that Satan has gained control of earth, so they immediately die when they are brought back to earth. When they return to Hell their memory of the fight and the lie that they face on earth is erased and wake up in hell ready to fight again for an escape that never lasts. The losers of the fight are put back into their pits to wait for the next fight.

## 3. Gameplay description
A 2D-platformer battleground/brawl game, where you alone or with a friend battle against other players for points to win the match. 
-	There 2-4 players in a match
-	The first player who gets 4 points wins, but a player must always win with at least a two point lead so if there is a player with 3 points then the winning player has to get the 4th point, which will be called an advantage, and then another final point to obtain the two point lead winning condition. (Winning condition is taken from the point system in Tennis).
    -	When advantage points are in play then the player with the advantage is given an extra power to be able to finish the game, and if the player fails to complete the next objective or gets knocked out he loses the advantage and therefore the powerup.
        -	The powerup will not be too strong so that the other player/s still has/have a chance to win. 
        -	After some time has passed the powerups gets more powerful to ensure the game does not run for too long.

You gather points through doing objectives that spawn on the playing field.
-	The objectives that spawn on the board are only there for a certain amount of time and then they disappear, so players must gather as many points before they disappear. 

Battle is done mostly in close combat with punches and kicks, and players can knock out other players for a few seconds.
-	Players have a health bar that lowers as they take damage and when the health bar is at 0 the player is knocked out for a few seconds and then they can continue fighting. 

There are also possibilities for other types of combat style through items that they can collect on the map and with ultimate attacks gained through combat energy. (EXTRA)
- During the match crates will appear and when broken they will give you and item to fight with.
- Each player has an energy bar which is filled when successful attacks are performed against other players. When that bar is full the player can perform an ultimate attack.
    - An extra method to gain combat energy is getting them by completing objectives.

Playable characters: WIP. Classes, default character for everyone or custom setup at main menu.
## 4. Artistic Style Outline
- Demonic
- Horror
- Intense
- Hot (Hot colours)

## 5. Systematic Breakdown of Components

### 5.1 User interface
### 5.2 AI
### 5.3 Input
### 5.4 2D renderer
### 5.5 Multiplayer
### 5.6 Save/load
### 5.7 Sound

## 6. Assets Breakdown

### 6.1 Art Assets
### 6.2 Text Assets
### 6.3 Sound Assets

## 7. Game Flow Diagram

Example:  (ie. Start Game -> Cutscene -> Tutorial -> loop(Cutscene -> Level -> Results Screen) -> End)

## 8. Development process

### 8.1 Teamwork
### 8.2 Timeline
### 8.3 Testing
### 8.4 Documentation
### 8.5 Hardware requirements
### 8.6 Tech stack

## 9. Misc

## 10. References

